/* mpeg2enc.c, main() and parameter file reading                            */

/* Copyright (C) 1996, MPEG Software Simulation Group. All Rights Reserved. */

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  The MPEG Software Simulation Group disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 * The MPEG Software Simulation Group does not represent or warrant that the
 * programs furnished hereunder are free of infringement of any third-party
 * patents.
 *
 * Commercial implementations of MPEG-1 and MPEG-2 video, including shareware,
 * are subject to royalty fees to patent holders.  Many of these patents are
 * general enough such that they are unavoidable regardless of implementation
 * design.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <netdb.h>
#include <pthread.h>
//#include <sys/types.h>
#include <fcntl.h>


#define GLOBAL			/* used by global.h */
#include "config.h"
#include "global.h"
#include "common.h"

/* private prototypes */
static void init _ANSI_ARGS_((void));
static void readparmfile _ANSI_ARGS_((char *fname));
static void readquantmat _ANSI_ARGS_((void));
void* Run_Network_Thread (void *arg);

struct sockaddr_in dec, enc_A;//, enc_Y, enc_U, enc_V, enc_P;
struct hostent *enchostent;
struct hostent *phostent;
int senc_A;//senc_Y, senc_U, senc_V, senc_P;
int outsk;
int n;
int s, icli;
struct sockaddr_in sin, cli;

int MV_bypass=0;

/******************THIS FILE WAS CREATED BY KENT MEDIANET**********************/
//pthread_t net_thread;

FILE *net_par;
FILE *enc_net_file;
char enc_id[10], enc_ip[50], enc_port[10];
char srv_id[10], srv_ip[50], srv_port[10];
char xcoder_id[10], xcoder_ip[10], xcoder_port[10];


int main(argc, argv)
int argc;
char *argv[];
{
    int n;
    int s, icli;
    struct sockaddr_in sin, cli;

// Parameters elimination
    int argc_tmp=3;
    int *argv_tmp[10];

/******************THIS FILE WAS CREATED BY KENT MEDIANET**********************/

//    pthread_create(&net_thread, NULL, Run_Network_Thread, NULL);

    enc_dynamic_bypass_on = ON;

    /*Open file with eye gazes*/
/*
    if((eyegaze = fopen("enc_eye.in","r"))==NULL)
     	printf("File eye.out could not opened\n");
    else
     fscanf(eyegaze,"%s %s %s %s\n",X,Y,A,B);
*/

//Creating the log file for encoder to collect the info
    if((fenclog = fopen("enc_log.out","w"))==NULL)
    {
      printf("XENC: error opening enc_log.out file for writting\n");
    }


    strcpy(xcoder_port,argv[1]);
    printf("XCODER port is %s\n",xcoder_port);

    argv_tmp[0]="./mpeg2encode";
    argv_tmp[1]="test.par";
    argv_tmp[2]="new.m2v";
    argv_tmp[3]="1";

    if (argc_tmp < 3)
    {
	printf("\n%s, %s\n", version, author);
	printf("Usage: mpeg2encode in.par out.m2v\n");
	exit(0);
    }
    sscanf(argv_tmp[3], "%d", &flag);

  flag=1;  
// Checking for MV bypass
  if(strcmp("1",argv[3])==0)
    MV_bypass=1;
  else
    MV_bypass=0;    


//    sleep(2);

/******************MEDIANET **********************************/
/* Temprorary slolution - assining to decoder the role of the server -
   slightly changed file net.par */
/*
    if((enc_net_file = fopen("trn_net.par","r"))==NULL)
    {
      printf("File trn_net.par could not opened for reading\n");
    }
    else
    {
      fscanf(enc_net_file, "%s\t%s\t%s\n", &enc_id, &enc_ip, &enc_port);
    }
    fclose(enc_net_file);

    if(atoi(enc_port)>=6000)
      strcpy(enc_port,"5000");

    if((enc_net_file = fopen("trn_net.par","w"))==NULL)
    {
      printf("File trn_net.par could not opened for writting\n");
    }
    else
    {
      fprintf(enc_net_file, "%s\t%s\t%d\n",enc_id,enc_ip, atoi(enc_port)+5);
    }
    fclose(enc_net_file);
*/

    sleep(2);
    senc_A = socket(AF_INET, SOCK_STREAM, 0);
    bzero(&enc_A, sizeof(enc_A));
    enc_A.sin_family = AF_INET;
    enchostent = gethostbyname("localhost");
    memcpy(&(enc_A.sin_addr), enchostent->h_addr, enchostent->h_length);
    enc_A.sin_port = htons(5111);
    if (connect(senc_A, (struct sockaddr *) &enc_A, sizeof(enc_A)) ==-1)
    {
      close(senc_A);
      printf("Error with socket connection!\n");
      exit(1);
    }
    else
    {
      printf("Connection is established\n");
    }

/*


    sleep(2);
    senc_U = socket(AF_INET, SOCK_STREAM, 0);
    bzero(&enc_U, sizeof(enc_U));
    enc_U.sin_family = AF_INET;
    enchostent = gethostbyname(enc_ip);
    memcpy(&(enc_U.sin_addr), enchostent->h_addr, enchostent->h_length);
    enc_U.sin_port = htons((atoi(enc_port)+1));
    if (connect(senc_U, (struct sockaddr *) &enc_U, sizeof(enc_U)) ==-1)
    {
      close(senc_U);
      printf("Error with socket connection!\n");
      exit(1);
    }
    else
    {
      printf("Connection is established\n");
    }

    sleep(2);
    senc_V = socket(AF_INET, SOCK_STREAM, 0);
    bzero(&enc_V, sizeof(enc_V));
    enc_V.sin_family = AF_INET;
    enchostent = gethostbyname(enc_ip);
    memcpy(&(enc_V.sin_addr), enchostent->h_addr, enchostent->h_length);
    enc_V.sin_port = htons((atoi(enc_port)+2));
    if (connect(senc_V, (struct sockaddr *) &enc_V, sizeof(enc_V)) ==-1)
    {
      close(senc_V);
      printf("Error with socket connection!\n");
      exit(1);
    }
    else
    {
      printf("Connection is established\n");
    }

    sleep(2);
    senc_P = socket(AF_INET, SOCK_STREAM, 0);
    bzero(&enc_P, sizeof(enc_P));
    enc_P.sin_family = AF_INET;
    enchostent = gethostbyname(enc_ip);
    memcpy(&(enc_P.sin_addr), enchostent->h_addr, enchostent->h_length);
    enc_P.sin_port = htons((atoi(enc_port)+3));
    if (connect(senc_P, (struct sockaddr *) &enc_P, sizeof(enc_P)) ==-1)
    {
      close(senc_P);
      printf("Error with socket connection!\n");
      exit(1);
    }
    else
    {
      printf("Connection is established\n");
    }



    printf("XCODER: connection with player is established\n");
*/


     strcpy(line,argv[2]);
     sscanf(line, "%lf", &rate_global);
     rate_global=rate_global*1000;

    /* read parameter file */
    readparmfile(argv_tmp[1]);

    /* read quantization matrices */
    /*readquantmat();*/

    /* open output file */
    if (!(outfile = fopen(argv_tmp[2], "wb"))) {
	sprintf(errortext, "Couldn't create output file %s", argv_tmp[2]);
	error(errortext);
    }

    init();
    putseq();

    fclose(outfile);
    fclose(statfile);
    close(senc_A);
    fclose(fenclog);

/*
    close(senc_Y);
    close(senc_U);
    close(senc_V);
    close(senc_P);
*/    
    return 0;
}

static void init()
{
    int i, size;
    static int block_count_tab[3] = { 6, 8, 12 };

    initbits();
    init_fdct();
    init_idct();

    /* round picture dimensions to nearest multiple of 16 or 32 */
    mb_width = (horizontal_size + 15) / 16;
    mb_height =
	prog_seq ? (vertical_size +
		    15) / 16 : 2 * ((vertical_size + 31) / 32);
    mb_height2 = fieldpic ? mb_height >> 1 : mb_height;	/* for field pictures */
    width = 16 * mb_width;
    height = 16 * mb_height;

    chrom_width = (chroma_format == CHROMA444) ? width : width >> 1;
    chrom_height = (chroma_format != CHROMA420) ? height : height >> 1;

    height2 = fieldpic ? height >> 1 : height;
    width2 = fieldpic ? width << 1 : width;
    chrom_width2 = fieldpic ? chrom_width << 1 : chrom_width;

    block_count = block_count_tab[chroma_format - 1];

    /* clip table */
    if (!(clp = (unsigned char *) malloc(1024)))
	error("malloc failed\n");
    clp += 384;
    for (i = -384; i < 640; i++)
	clp[i] = (i < 0) ? 0 : ((i > 255) ? 255 : i);

    for (i = 0; i < 3; i++) {
	size = (i == 0) ? width * height : chrom_width * chrom_height;

	if (!(newrefframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(oldrefframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(auxframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(neworgframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(oldorgframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(auxorgframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
	if (!(predframe[i] = (unsigned char *) malloc(size)))
	    error("malloc failed\n");
    }

    mbinfo =
	(struct mbinfo *) malloc(mb_width * mb_height2 *
				 sizeof(struct mbinfo));

    if (!mbinfo)
	error("malloc failed\n");

    blocks =
	(short (*)[64]) malloc(mb_width * mb_height2 * block_count *
			       sizeof(short[64]));

    if (!blocks)
	error("malloc failed\n");

    /* open statistics output file */
    if (statname[0] == '-')
	statfile = stdout;
    else if (!(statfile = fopen(statname, "w"))) {
	sprintf(errortext, "Couldn't create statistics output file %s",
		statname);
	error(errortext);
    }
}
void error(text)
char *text;
{
    fprintf(stderr, text);
    putc('\n', stderr);
    exit(1);
}

static void readparmfile(fname)
char *fname;
{
    int i;
    int h, m, s, f;
    FILE *fd;
    char str[256];
    static double ratetab[8] =
	{ 24000.0 / 1001.0, 24.0, 25.0, 30000.0 / 1001.0, 30.0, 50.0,
	    60000.0 / 1001.0, 60.0 };
    extern int r, Xi, Xb, Xp, d0i, d0p, d0b;	/* rate control */
    extern double avg_act;	/* rate control */


/* Temporally changed
    ratepar = "rate.par";
    if (!(fdp = fopen(ratepar, "r"))) {
	sprintf(errortext, "Couldn't open parameter file rate.par");
	error(errortext);
    }
    fgets(line, 254, fdp);
    sscanf(line, "%lf", &ratep);
*/
  
  ratep=rate_global;
  printf("ENC: bit-rate is %f\n",ratep);
//End
      
/***********************KENT MEDIANET CHANGES *********************/
/*Reading net par file and coparing old bit rate with a new one,
if the new one is different the program will notify user about that*/
/*
    if (old_ratep != ratep) {
	printf("XCODER: changing rate parameter from %.1f to %.1f\n",
	       old_ratep, ratep);
    }
    old_ratep = ratep;
/***********************KENT MEDIANET CHANGES END*********************/
//    fclose(fdp);
/*

    if (!(fd = fopen(fname, "r"))) {
	sprintf(errortext, "Couldn't open parameter file %s", fname);
	error(errortext);
    }

    fgets(id_string, 254, fd);

    fgets(line, 254, fd);
    sscanf(line, "%d", &N);
    fgets(line, 254, fd);
    sscanf(line, "%d", &M);

    if (N < 1)
	error("N must be positive");
    if (M < 1)
	error("M must be positive");
    if (N % M != 0)
	error("N must be an integer multiple of M");
*/
//Parameters changes
    N=15;
    M=3;

    motion_data =
	(struct motion_data *) malloc(M * sizeof(struct motion_data));
    if (!motion_data)
	error("malloc failed\n");

    for (i = 0; i < M; i++)
    {

	if (i == 0)
        {
	    motion_data[i].forw_hor_f_code = 3;
	    motion_data[i].forw_vert_f_code = 3;
	    motion_data[i].sxf = 31;
	    motion_data[i].syf = 31;
	}
        else
        {
	    motion_data[i].forw_hor_f_code = 2;
	    motion_data[i].forw_vert_f_code = 2;
	    motion_data[i].sxf = 15;
	    motion_data[i].syf = 15;

	    motion_data[i].back_hor_f_code = 2;
	    motion_data[i].back_vert_f_code = 2;
	    motion_data[i].sxb = 15;
	    motion_data[i].syb = 15;
       }

/*
	if (i == 0)
        {
	    motion_data[i].forw_hor_f_code = 2;
	    motion_data[i].forw_vert_f_code = 2;
	    motion_data[i].sxf = 15;
	    motion_data[i].syf = 15;
	}
        else
        {
	    motion_data[i].forw_hor_f_code = 1;
	    motion_data[i].forw_vert_f_code = 1;
	    motion_data[i].sxf = 7;
	    motion_data[i].syf = 7;

	    motion_data[i].back_hor_f_code = 1;
	    motion_data[i].back_vert_f_code = 1;
	    motion_data[i].sxb = 7;
	    motion_data[i].syb = 7;
       }
*/
    }

//    fclose(fd);

    strcpy(id_string, "");	/* design some parameter for mpeg2 AVT */
    strcpy(tplorg, "mid%d");
    strcpy(tplref, "-");
    strcpy(statname, "stat.out");
    inputtype = 0;
    mpeg1 = 0;
    nframes = 10000;
    fieldpic = 0;
    P = 0;
    r = 0;
    avg_act = 0;
    Xi = 0;
    Xp = 0;
    Xb = 0;
    d0i = 0;
    d0p = 0;
    d0b = 0;
    frame_pred_dct_tab[0] = 0;
    frame_pred_dct_tab[1] = 0;
    frame_pred_dct_tab[2] = 0;
    conceal_tab[0] = 0;
    conceal_tab[1] = 0;
    conceal_tab[2] = 0;
    qscale_tab[0] = 1;
    qscale_tab[1] = 1;
    qscale_tab[2] = 1;
    intravlc_tab[0] = 1;
    intravlc_tab[1] = 0;
    intravlc_tab[2] = 0;
    altscan_tab[0] = 0;
    altscan_tab[1] = 0;
    altscan_tab[2] = 0;

    /* get parameters from the dec */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &horizontal_size);
    /* printf("**** %s%d",line,horizontal_size); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &vertical_size);
    /* printf("**** %s%d",line,vertical_size); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &aspectratio);
    /* printf("**** %s%d",line,aspectratio); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &frame_rate_code);
    /* printf("**** %s%d",line,frame_rate_code); */
    read(senc_A, line, 256);
    sscanf(line, "%s%lf", str, &bit_rate);
    bit_rate = 400.0 * bit_rate;
    /* printf("**** %s%lf",line,bit_rate); */
    /*printf("bit_rate = %lf %lf\n",bit_rate,ratep);
       if(ratep!=0.0)
       bit_rate = ratep; */
    /* printf("bit_rate = %lf\n",bit_rate); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &vbv_buffer_size);
    /* printf("**** %s%d",line,vbv_buffer_size); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &constrparms);
    /* printf("**** %s%d",line,constrparms); */
    read(senc_A, line, 256);
    sscanf(line, "%s%s", str, iqname);
    /* printf("**** %s %s",line,iqname); */
    read(senc_A, line, 256);
    sscanf(line, "%s%s", str, niqname);
    /* printf("**** %s%s",line,niqname); */
    readquantmat();
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &profile);
    /* printf("**** %s %d",line,profile); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &level);
    /* printf("**** %s %d",line,level); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &prog_seq);
    /* printf("**** %s %d",line,prog_seq); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &chroma_format);
    /* printf("**** %s%d",line,chroma_format); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &low_delay);
    /* printf("**** %s %d",line,low_delay); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &video_format);
    /* printf("**** %s %d",line,video_format); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &color_primaries);
    /* printf("**** %s %d",line,color_primaries); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &transfer_characteristics);
    /* printf("**** %s %d",line,transfer_characteristics); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &matrix_coefficients);
    /* printf("**** %s %d",line,matrix_coefficients); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &display_horizontal_size);
    /* printf("**** %s %d",line,display_horizontal_size); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &display_vertical_size);
    /* printf("**** %s %d",line,display_vertical_size); */
    read(senc_A, line, 256);
    sscanf(line, "%s %d:%02d:%02d:%02d", str, &h, &m, &s, &f);
    /* printf("**** %s %d:%02d:%02d:%02d\n",line,h,m,s,f); */
    frame0 = f;
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &dc_prec);
    /* printf("**** %s %d",line,dc_prec); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &topfirst);
    /* printf("**** %s %d",line,topfirst); */
    read(senc_A, line, 256);
    sscanf(line, "%s%d", str, &repeatfirst);
    /* printf("**** %s %d",line,repeatfirst); */
    do {
	i = read(senc_A, line, 256);
    } while (!i);
    sscanf(line, "%s%d", str, &prog_frame);
    /* printf("**** %s %d ",line,prog_frame); */

    /* make flags boolean (x!=0 -> x=1) */
    mpeg1 = !!mpeg1;
    fieldpic = !!fieldpic;
    low_delay = !!low_delay;
    constrparms = !!constrparms;
    prog_seq = !!prog_seq;
    topfirst = !!topfirst;

    for (i = 0; i < 3; i++) {
	frame_pred_dct_tab[i] = !!frame_pred_dct_tab[i];
	conceal_tab[i] = !!conceal_tab[i];
	qscale_tab[i] = !!qscale_tab[i];
	intravlc_tab[i] = !!intravlc_tab[i];
	altscan_tab[i] = !!altscan_tab[i];
    }
    repeatfirst = !!repeatfirst;
    prog_frame = !!prog_frame;

    /* make sure MPEG specific parameters are valid */
    range_checks();



    if(NETWORK_ON) /*Network ON/OFF*/
    {
/*
      if ((net_par = fopen("net.par", "r")) == NULL)
   	printf("Usage:[net.par] could not opened\n");
      else
      {
	fscanf(net_par, "%s\t%s\t%s\n", srv_id, srv_ip, srv_port);
	fscanf(net_par, "%s\t%s\t%s\n", xcoder_id, xcoder_ip, xcoder_port);
      }
      fclose(net_par);
*/
      printf("XCODER: assined port for communication with player %d test\n",atoi(xcoder_port));
      s = socket(AF_INET, SOCK_STREAM, 0);
      bzero(&sin, sizeof(sin));
      sin.sin_family = AF_INET;
      sin.sin_addr.s_addr = htonl(INADDR_ANY);
      sin.sin_port = htons(atoi(xcoder_port));

      bind(s, (struct sockaddr *) &sin, sizeof(sin));
      listen(s, 4096);
      printf("XCODER: waiting for connection with player ...\n");
      outsk = accept(s, (struct sockaddr *) &cli, &icli);
      printf("XCODER: connection accepted ...\n");
      flag = 0;
      n = 0;
    }



    frame_rate = ratetab[frame_rate_code - 1];

    /* timecode -> frame number */
    tc0 = h;
    tc0 = 60 * tc0 + m;
    tc0 = 60 * tc0 + s;
    tc0 = (int) (frame_rate + 0.5) * tc0 + f;

    if (!mpeg1) {
	profile_and_level_checks();
    } else {
	/* MPEG-1 */
	if (constrparms) {
	    if (horizontal_size > 768
		|| vertical_size > 576
		|| ((horizontal_size + 15) / 16) * ((vertical_size + 15) /
						    16) > 396
		|| ((horizontal_size + 15) / 16) * ((vertical_size + 15) /
						    16) * frame_rate >
		396 * 25.0 || frame_rate > 30.0) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: setting constrained_parameters_flag = 0\n");
		constrparms = 0;
	    }
	}

	if (constrparms) {
	    for (i = 0; i < M; i++) {
		if (motion_data[i].forw_hor_f_code > 4) {
		    if (!quiet)
			fprintf(stderr,
				"Warning: setting constrained_parameters_flag = 0\n");
		    constrparms = 0;
		    break;
		}

		if (motion_data[i].forw_vert_f_code > 4) {
		    if (!quiet)
			fprintf(stderr,
				"Warning: setting constrained_parameters_flag = 0\n");
		    constrparms = 0;
		    break;
		}

		if (i != 0) {
		    if (motion_data[i].back_hor_f_code > 4) {
			if (!quiet)
			    fprintf(stderr,
				    "Warning: setting constrained_parameters_flag = 0\n");
			constrparms = 0;
			break;
		    }

		    if (motion_data[i].back_vert_f_code > 4) {
			if (!quiet)
			    fprintf(stderr,
				    "Warning: setting constrained_parameters_flag = 0\n");
			constrparms = 0;
			break;
		    }
		}
	    }
	}
    }

    /* relational checks */

    if (mpeg1) {
	if (!prog_seq) {
	    if (!quiet)
		fprintf(stderr,
			"Warning: setting progressive_sequence = 1\n");
	    prog_seq = 1;
	}

	if (chroma_format != CHROMA420) {
	    if (!quiet)
		fprintf(stderr,
			"Warning: setting chroma_format = 1 (4:2:0)\n");
	    chroma_format = CHROMA420;
	}

	if (dc_prec != 0) {
	    if (!quiet)
		fprintf(stderr,
			"Warning: setting intra_dc_precision = 0\n");
	    dc_prec = 0;
	}

	for (i = 0; i < 3; i++)
	    if (qscale_tab[i]) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: setting qscale_tab[%d] = 0\n", i);
		qscale_tab[i] = 0;
	    }

	for (i = 0; i < 3; i++)
	    if (intravlc_tab[i]) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: setting intravlc_tab[%d] = 0\n", i);
		intravlc_tab[i] = 0;
	    }

	for (i = 0; i < 3; i++)
	    if (altscan_tab[i]) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: setting altscan_tab[%d] = 0\n", i);
		altscan_tab[i] = 0;
	    }
    }

    if (!mpeg1 && constrparms) {
	if (!quiet)
	    fprintf(stderr,
		    "Warning: setting constrained_parameters_flag = 0\n");
	constrparms = 0;
    }

    if (prog_seq && !prog_frame) {
	if (!quiet)
	    fprintf(stderr, "Warning: setting progressive_frame = 1\n");
	prog_frame = 1;
    }

    if (prog_frame && fieldpic) {
	if (!quiet)
	    fprintf(stderr, "Warning: setting field_pictures = 0\n");
	fieldpic = 0;
    }

    if (!prog_frame && repeatfirst) {
	if (!quiet)
	    fprintf(stderr, "Warning: setting repeat_first_field = 0\n");
	repeatfirst = 0;
    }

    if (prog_frame) {
	for (i = 0; i < 3; i++)
	    if (!frame_pred_dct_tab[i]) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: setting frame_pred_frame_dct[%d] = 1\n",
			    i);
		frame_pred_dct_tab[i] = 1;
	    }
    }

    if (prog_seq && !repeatfirst && topfirst) {
	if (!quiet)
	    fprintf(stderr, "Warning: setting top_field_first = 0\n");
	topfirst = 0;
    }

    /* search windows */
    for (i = 0; i < M; i++) {
	if (motion_data[i].sxf > (4 << motion_data[i].forw_hor_f_code) - 1) {
	    if (!quiet)
		fprintf(stderr,
			"Warning: reducing forward horizontal search width to %d\n",
			(4 << motion_data[i].forw_hor_f_code) - 1);
	    motion_data[i].sxf = (4 << motion_data[i].forw_hor_f_code) - 1;
	}

	if (motion_data[i].syf >
	    (4 << motion_data[i].forw_vert_f_code) - 1) {
	    if (!quiet)
		fprintf(stderr,
			"Warning: reducing forward vertical search width to %d\n",
			(4 << motion_data[i].forw_vert_f_code) - 1);
	    motion_data[i].syf =
		(4 << motion_data[i].forw_vert_f_code) - 1;
	}

	if (i != 0) {
	    if (motion_data[i].sxb >
		(4 << motion_data[i].back_hor_f_code) - 1) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: reducing backward horizontal search width to %d\n",
			    (4 << motion_data[i].back_hor_f_code) - 1);
		motion_data[i].sxb =
		    (4 << motion_data[i].back_hor_f_code) - 1;
	    }

	    if (motion_data[i].syb >
		(4 << motion_data[i].back_vert_f_code) - 1) {
		if (!quiet)
		    fprintf(stderr,
			    "Warning: reducing backward vertical search width to %d\n",
			    (4 << motion_data[i].back_vert_f_code) - 1);
		motion_data[i].syb =
		    (4 << motion_data[i].back_vert_f_code) - 1;
	    }
	}
    }

}

static void readquantmat()
{
    int i, v;
    /* FILE *fd; */
    if (iqname[0] == '0') {
	/* use default intra matrix */
	load_iquant = 0;
	for (i = 0; i < 64; i++)
	    intra_q[i] = default_intra_quantizer_matrix[i];
    } else {
	/* read customized intra matrix */
	load_iquant = 1;
	/*if (!(fd = fopen(iqname,"r")))
	   {
	   sprintf(errortext,"Couldn't open quant matrix file %s",iqname);
	   error(errortext);
	   } */

	for (i = 0; i < 64; i++) {
	    read(senc_A, line, 256);
	    sscanf(line, "%d", &v);
	    if (v < 1 || v > 255)
		error("invalid value in quant matrix");
	    intra_q[i] = v;
	}

	/* fclose(fd); */
    }

    if (niqname[0] == '0') {
	/* use default non-intra matrix */
	load_niquant = 0;
	for (i = 0; i < 64; i++)
	    inter_q[i] = 16;
    } else {
	/* read customized non-intra matrix */
	load_niquant = 1;
	/*if (!(fd = fopen(niqname,"r")))
	   {
	   sprintf(errortext,"Couldn't open quant matrix file %s",niqname);
	   error(errortext);
	   } */

	for (i = 0; i < 64; i++) {
	    read(senc_A, line, 256);
	    sscanf(line, "%d", &v);
	    if (v < 1 || v > 255)
		error("invalid value in quant matrix");
	    inter_q[i] = v;
	}

	/* fclose(fd); */
    }
}

/******************THIS FILE WAS CREATED BY KENT MEDIANET**********************/
void Read_Decodedframe_Bypass()
{
/*
    FILE *ebp;
    char temp_name[256];
    chdir("./test");
    memset(frameinfo, '\0', 100);
    sprintf(frameinfo, "encframebypass%d.txt", encframe);
    if((ebp = fopen(frameinfo, "r")) == NULL) 
    {
	enc_dynamic_bypass_on = ON;
	if(ECHO)
 	  printf("FILE encframebypass%d.txt NOT FOUND.SET ENC_DYNAMIC_BYPASS ON\n",encframe);
    }
    else
    {
      fscanf(ebp, "%d %d %d\n",&enc_dynamic_bypass_on, &enc_frame_bypass_on, &enc_framecount);
      if(ECHO)printf("ENC: read bypass.par %d %d %d\n, file  %sd\n",enc_dynamic_bypass_on,
                        enc_frame_bypass_on,enc_framecount,frameinfo);
    }  
    fclose(ebp);
    memset(temp_name, '\0', 256);
    sprintf(temp_name, "rm %s", frameinfo);
    system(temp_name);
*/
   enc_dynamic_bypass_on=0;
   enc_frame_bypass_on=MV_bypass;
   enc_framecount=0;    
}

/*
void* Run_Network_Thread(void *arg)
{
   struct sockaddr_in e_ser, e_cli;
   int err;
   int e_s;
   int e_s2;
   int e_icli;
   int e_ird;
   int e_iwd;
   char e_buf[2048];
   char e_srv_port[10]="5112";
   int frame_number=0;
   int ird, iwd;
   int fenc;
   char filename[256];
   int i=0;
   FILE *temp_file;

//   printf("MV Bypass Thread\n");
//   printf("MV port assined %d\n", 5112);


   if((e_s= socket(AF_INET, SOCK_STREAM, 0))<0)
   {
    printf("MV Can't open communication socket s=%d\n",e_s);
   }    
   else
   {
//    printf("MV Socket is opened=%d\n",e_s);
   }
       
   bzero(&e_ser, sizeof(e_ser));
   e_ser.sin_family = AF_INET;
   e_ser.sin_addr.s_addr = htonl(INADDR_ANY);
   e_ser.sin_port = htons(5112);

   bind(e_s, (struct sockaddr *) &e_ser, sizeof(e_ser));
   if((err=listen(e_s, 1))<0)
     printf("MV Listen - failed %d\n",err);
   else
   {
//     printf("MV Listen succesfull %d\n",err);
   }
        
   for(;;)
   {
     if((e_s2 = accept(e_s, (struct sockaddr *) &e_cli, &e_icli))<0)
       printf("MV Can't open communication socket\n");
     else
     {
//      printf("MV s2=%d\n",e_s2);
     }  

    memset(filename, '\0', 100);
    sprintf(filename, "Dlog%df.txt",i);
 //   temp_file = fopen("temp","w");
 //   close(temp_file);

    if ((fenc = open(filename, O_TRUNC|O_CREAT|O_WRONLY,0666)) <0)
    {
	printf("Error opening file %s.\n",filename);
	exit(1);
    }
    else
    {
//	printf("MV file %s is opened sucsessfully\n",filename);
    }

    while((ird=read(e_s2,e_buf,2048))>0)
    {
      if((iwd=write(fenc,e_buf,ird))<0)
        printf("Error writing file Dlog%df.txt",i);
    }
//    printf("%s\n",e_buf);
    close(e_s2);
    close(fenc);
    i++;
   }
    close(e_s);
}
*/